//************************************************************************
//*            Dmonstrateur de FORM pour BipGDI  VERSION 1.1            *
//*----------------------------------------------------------------------*
//*                                                                      *
//*    Require : BipGDI Win V0.9.4                                       *
//*    Require : BipDate Win V0.9.2                                      *
//*    Require : BipNum Win V0.9.2                                       *
//*                                                                      *
//* Licence : NFM                                                        *
//************************************************************************

#pragma comment (lib, "comctl32.lib")


#include <windows.h>
#include <string>


// Include for Bip
#include "BipGDI.h"


	using namespace std;



//-------------------------------------------------------------
//!        Prototypes des fonctions                           !
//-------------------------------------------------------------
//void Load_Menu (void);
//void Form_Edit (void);



//-------------------------------------------------------------
//!        Chargement du menu                                 !
//-------------------------------------------------------------
void Load_Menu (void)
{
	int iError;

	// cration du menu fichier
	iError = BG_MenuAdd ("menu", "fichier", 1, 1, "&Fichier", "");
	iError = BG_MenuAdd ("menu", "ouvrir", 1, 2, "&Ouvrir", "");
	iError = BG_MenuAdd ("menu", "-", 1, 3, "");
	iError = BG_MenuAdd ("menu", "quitter", 1, 4, "&Quitter", "");

	// cration du menu form
	iError = BG_MenuAdd ("menu", "form", 2, 1, "F&ormulaires", "");
	iError = BG_MenuAdd ("menu", "tous", 2, 2, "&Tous les champs", "");
	iError = BG_MenuAdd ("menu", "static", 2, 3, "Le champ &Static", "");
	iError = BG_MenuAdd ("menu", "edit", 2, 4, "&Edit", "");

	// affichage du menu
	iError = BG_MenuDisplay ("Main", "menu");
}



//-------------------------------------------------------------
//!        Traitement du formulaire Static                    !
//-------------------------------------------------------------
int Form_Static_Proc (const string sBGFormName, const string sBGItemName, const string sBGMessage,
				HWND hBGCurWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int iError;
	string sString;
	BG_STRUCT_FORMITEM TmpItem;

	// sur modification d'un champ
	if (sBGMessage == BG_MSG_ITEMCHANGE)
	{
		// si modification du champ "cbpolice"
		if (sBGItemName == "cbpolice")
		{
			// retrouve la structure du champ
			TmpItem = BG_FormItemGet (sBGFormName, sBGItemName);

			// modifie la police de caractre
			iError = BG_FormItemModify (sBGFormName, "static1", BG_PRM_FTNAME, TmpItem.sReturn);

			// quitte la fonction
			return 0;
		}

		// si modification du champ "cbtaille"
		if (sBGItemName == "cbtaille")
		{
			// retrouve la structure du champ
			TmpItem = BG_FormItemGet (sBGFormName, sBGItemName);

			// modifie la taille de la police de caractre
			iError = BG_FormItemModify (sBGFormName, "static1", BG_PRM_FTSIZE, TmpItem.sReturn);

			// quitte la fonction
			return 0;
		}

		// si modification du champ "gras"
		if (sBGItemName == "gras")
		{
			// retrouve la structure du champ
			TmpItem = BG_FormItemGet (sBGFormName, sBGItemName);

			// selon l'tat du checkbox
			sString = "false";
			if (TmpItem.bReturn == true)
				sString = "true";

			// modifie la police de caractre
			iError = BG_FormItemModify (sBGFormName, "static1", BG_PRM_FTBOLD, sString);

			// quitte la fonction
			return 0;
		}

		// si modification du champ "italique"
		if (sBGItemName == "italique")
		{
			// retrouve la structure du champ
			TmpItem = BG_FormItemGet (sBGFormName, sBGItemName);

			// selon l'tat du checkbox
			sString = "false";
			if (TmpItem.bReturn == true)
				sString = "true";

			// modifie la police de caractre
			iError = BG_FormItemModify (sBGFormName, "static1", BG_PRM_FTITALIC, sString);

			// quitte la fonction
			return 0;
		}

		// si modification du champ "souligne"
		if (sBGItemName == "souligne")
		{
			// retrouve la structure du champ
			TmpItem = BG_FormItemGet (sBGFormName, sBGItemName);

			// selon l'tat du checkbox
			sString = "false";
			if (TmpItem.bReturn == true)
				sString = "true";

			// modifie la police de caractre
			iError = BG_FormItemModify (sBGFormName, "static1", BG_PRM_FTULINE, sString);

			// quitte la fonction
			return 0;
		}

		// si modification du champ "cbcouleurtexte"
		if (sBGItemName == "cbcouleurtexte")
		{
			// retrouve la structure du champ
			TmpItem = BG_FormItemGet (sBGFormName, sBGItemName);

			// modifie la couleur
			iError = BG_FormItemModify (sBGFormName, "static1", BG_PRM_TEXTCOLOR, TmpItem.sReturn);

			// quitte la fonction
			return 0;
		}

		// si modification du champ "cbcouleurfond"
		if (sBGItemName == "cbcouleurfond")
		{
			// retrouve la structure du champ
			TmpItem = BG_FormItemGet (sBGFormName, sBGItemName);

			// modifie la couleur
			iError = BG_FormItemModify (sBGFormName, "static1", BG_PRM_BACKCOLOR, TmpItem.sReturn);

			// quitte la fonction
			return 0;
		}

		// si modification du champ "cbtaillebrd"
		if (sBGItemName == "cbtaillebrd")
		{
			// retrouve la structure du champ
			TmpItem = BG_FormItemGet (sBGFormName, sBGItemName);

			// modifie la taille de la police de caractre
			iError = BG_FormItemModify (sBGFormName, "static1", BG_PRM_BRDSIZE, TmpItem.sReturn);

			// quitte la fonction
			return 0;
		}

		// si modification du champ "cbcouleurbrd"
		if (sBGItemName == "cbcouleurbrd")
		{
			// retrouve la structure du champ
			TmpItem = BG_FormItemGet (sBGFormName, sBGItemName);

			// modifie la couleur
			iError = BG_FormItemModify (sBGFormName, "static1", BG_PRM_BRDCOL, TmpItem.sReturn);

			// quitte la fonction
			return 0;
		}

		// si modification du champ "cbstylebrd"
		if (sBGItemName == "cbstylebrd")
		{
			// retrouve la structure du champ
			TmpItem = BG_FormItemGet (sBGFormName, sBGItemName);

			// modifie la couleur
			iError = BG_FormItemModify (sBGFormName, "static1", BG_PRM_BRDSTYLE, TmpItem.sReturn);

			// quitte la fonction
			return 0;
		}

		// si modification du champ "cbhorizalign"
		if (sBGItemName == "cbhorizalign")
		{
			// retrouve la structure du champ
			TmpItem = BG_FormItemGet (sBGFormName, sBGItemName);

			// modifie l'alignement
			iError = BG_FormItemModify (sBGFormName, "static1", BG_PRM_TXHPOS, TmpItem.sReturn);

			// quitte la fonction
			return 0;
		}

		// si modification du champ "cbverticalign"
		if (sBGItemName == "cbverticalign")
		{
			// retrouve la structure du champ
			TmpItem = BG_FormItemGet (sBGFormName, sBGItemName);

			// modifie l'alignement
			iError = BG_FormItemModify (sBGFormName, "static1", BG_PRM_TXVPOS, TmpItem.sReturn);

			// quitte la fonction
			return 0;
		}
	}

	// en sortie du champ "texte"
	if (sBGItemName == "texte" && sBGMessage == BG_MSG_ITEMEXIT)
	{
		// retrouve la structure du champ
		TmpItem = BG_FormItemGet (sBGFormName, sBGItemName);

		// modifie le texte
		iError = BG_FormItemModify (sBGFormName, "static1", BG_PRM_VALUE, TmpItem.sReturn);

		// quitte la fonction
		return 0;
	}


	return 0;
}



//-------------------------------------------------------------
//!        Traitement du formulaire Edit                      !
//-------------------------------------------------------------
int Form_Edit_Proc (const string sBGFormName, const string sBGItemName, const string sBGMessage,
				HWND hBGCurWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int iError;
	string sString;
	BG_STRUCT_FORMITEM TmpItem;


	// sur modification d'un champ
	if (sBGMessage == BG_MSG_ITEMCLIC)
	{
		// si clic du bouton "desactiver"
		if (sBGItemName == "desactiver")
		{
			// retrouve la structure du champ
			TmpItem = BG_FormItemGet (sBGFormName, sBGItemName);

			// dsactive les champs sauf le bouton "activer"
			iError = BG_FormItemModify (sBGFormName, "champ1", BG_PRM_ENABLE, "false");
			iError = BG_FormItemModify (sBGFormName, "champ2", BG_PRM_ENABLE, "false");
			iError = BG_FormItemModify (sBGFormName, "champ3", BG_PRM_ENABLE, "false");
			iError = BG_FormItemModify (sBGFormName, "champ4", BG_PRM_ENABLE, "false");
			iError = BG_FormItemModify (sBGFormName, "check", BG_PRM_ENABLE, "false");
			iError = BG_FormItemModify (sBGFormName, "desactiver", BG_PRM_ENABLE, "false");
			iError = BG_FormItemModify (sBGFormName, "activer", BG_PRM_ENABLE, "true");

			// quitte la fonction
			return 0;
		}

		// si clic du bouton "activer"
		if (sBGItemName == "activer")
		{
			// retrouve la structure du champ
			TmpItem = BG_FormItemGet (sBGFormName, sBGItemName);

			// active les champs sauf le bouton "desactiver"
			iError = BG_FormItemModify (sBGFormName, "champ1", BG_PRM_ENABLE, "true");
			iError = BG_FormItemModify (sBGFormName, "champ2", BG_PRM_ENABLE, "true");
			iError = BG_FormItemModify (sBGFormName, "champ3", BG_PRM_ENABLE, "true");
			iError = BG_FormItemModify (sBGFormName, "champ4", BG_PRM_ENABLE, "true");
			iError = BG_FormItemModify (sBGFormName, "check", BG_PRM_ENABLE, "true");
			iError = BG_FormItemModify (sBGFormName, "desactiver", BG_PRM_ENABLE, "true");
			iError = BG_FormItemModify (sBGFormName, "activer", BG_PRM_ENABLE, "false");

			// quitte la fonction
			return 0;
		}

		// si clic du bouton "masquer"
		if (sBGItemName == "masquer")
		{
			// retrouve la structure du champ
			TmpItem = BG_FormItemGet (sBGFormName, sBGItemName);

			// masque les champs sauf le bouton "montrer"
			iError = BG_FormItemModify (sBGFormName, "champ1", BG_PRM_VISIBLE, "false");
			iError = BG_FormItemModify (sBGFormName, "champ2", BG_PRM_VISIBLE, "false");
			iError = BG_FormItemModify (sBGFormName, "champ3", BG_PRM_VISIBLE, "false");
			iError = BG_FormItemModify (sBGFormName, "champ4", BG_PRM_VISIBLE, "false");
			iError = BG_FormItemModify (sBGFormName, "check", BG_PRM_VISIBLE, "false");
			iError = BG_FormItemModify (sBGFormName, "masquer", BG_PRM_VISIBLE, "false");
			iError = BG_FormItemModify (sBGFormName, "montrer", BG_PRM_VISIBLE, "true");

			// quitte la fonction
			return 0;
		}

		// si clic du bouton "montrer"
		if (sBGItemName == "montrer")
		{
			// retrouve la structure du champ
			TmpItem = BG_FormItemGet (sBGFormName, sBGItemName);

			// active les champs sauf le bouton "desactiver"
			iError = BG_FormItemModify (sBGFormName, "champ1", BG_PRM_VISIBLE, "true");
			iError = BG_FormItemModify (sBGFormName, "champ2", BG_PRM_VISIBLE, "true");
			iError = BG_FormItemModify (sBGFormName, "champ3", BG_PRM_VISIBLE, "true");
			iError = BG_FormItemModify (sBGFormName, "champ4", BG_PRM_VISIBLE, "true");
			iError = BG_FormItemModify (sBGFormName, "check", BG_PRM_VISIBLE, "true");
			iError = BG_FormItemModify (sBGFormName, "masquer", BG_PRM_VISIBLE, "true");
			iError = BG_FormItemModify (sBGFormName, "montrer", BG_PRM_VISIBLE, "false");

			// quitte la fonction
			return 0;
		}

	}

	return 0;
}



//-------------------------------------------------------------
//!        Affichage du formulaire Static                     !
//-------------------------------------------------------------
void Form_Static (void)
{
	int iItem;
	int iError;

	// initialisation numero de l'item
	iItem = 1;

	// cration du titre
	iError = BG_FormItemAdd ("static", "titre", BG_ITEM_STATIC, iItem++, 50, 10, 600, 40,
				"value=Dmonstrateur Formulaire BipGDI (static);txhpos=center;txvpos=center;ftname=Arial;ftsize=16;ftbold=true;brdsize=1;brdcol=blue");
	iError = BG_FormItemAdd ("static", "rectangle1", BG_ITEM_RECT, iItem++, 50, 60, 600, 370,
				"brdsize=1;brdstyle=3DOUT");


	iError = BG_FormItemAdd ("static", "static1", BG_ITEM_STATIC, iItem++, 140, 65, 400, 50,
				"value=Exemple de champ static;brdsize=1;bkcol=white;ftname=Arial;ftsize=10");

	iError = BG_FormItemAdd ("static", "police", BG_ITEM_STATIC, iItem++, 60, 120, 180, 25,
				"value=Police;txvpos=center");
	iError = BG_FormItemAdd ("static", "cbpolice", BG_ITEM_COMBOSYS, iItem++, 180, 120, 160, 100,
				"value1=Arial;value2=Courier New;value3=Times New Roman;remark=Police du champ STATIC");

	iError = BG_FormItemAdd ("static", "taille", BG_ITEM_STATIC, iItem++, 360, 120, 130, 25,
				"value=Taille;txvpos=center");
	iError = BG_FormItemAdd ("static", "cbtaille", BG_ITEM_COMBOSYS, iItem++, 500, 120, 50, 100,
				"value1=10;value2=6;value3=8;value4=12;value5=14;value6=18;value7=24;value8=36;value9=72;remark=Taille de la police de caractre");

	iError = BG_FormItemAdd ("static", "grastexte", BG_ITEM_STATIC, iItem++, 60, 150, 180, 25,
				"value=Gras;txvpos=center");
	iError = BG_FormItemAdd ("static", "gras", BG_ITEM_CHECKSYS, iItem++, 180, 155, 100, 100,
				"remark=Validez pour mettre le texte en gras");

	iError = BG_FormItemAdd ("static", "italiquetexte", BG_ITEM_STATIC, iItem++, 260, 150, 180, 25,
				"value=Italique;txvpos=center");
	iError = BG_FormItemAdd ("static", "italique", BG_ITEM_CHECKSYS, iItem++, 340, 155, 100, 100,
				"remark=Validez pour mettre le texte en italique");

	iError = BG_FormItemAdd ("static", "soulignetexte", BG_ITEM_STATIC, iItem++, 460, 150, 180, 25,
				"value=Soulign;txvpos=center");
	iError = BG_FormItemAdd ("static", "souligne", BG_ITEM_CHECKSYS, iItem++, 540, 155, 100, 100,
				"remark=Validez pour mettre le texte en soulign");

	iError = BG_FormItemAdd ("static", "couleurtexte", BG_ITEM_STATIC, iItem++, 60, 180, 180, 25,
				"value=Couleur du texte;txvpos=center;txcol=blue");
	iError = BG_FormItemAdd ("static", "cbcouleurtexte", BG_ITEM_COMBOSYS, iItem++, 180, 180, 100, 100,
				"value1=BLACK;value2=WHITE;value3=RED;value4=BLUE;value5=GREEN;value6=YELLOW;value7=MAGENTA;value8=CYAN;value9=MAGENTA;value10=LIGHTGREY;value11=DARKGREY;remark=Couleur du texte du champ STATIC");

	iError = BG_FormItemAdd ("static", "couleurfond", BG_ITEM_STATIC, iItem++, 360, 180, 130, 25,
				"value=Couleur du fond;txvpos=center;txcol=white;bkcol=grey");
	iError = BG_FormItemAdd ("static", "cbcouleurfond", BG_ITEM_COMBOSYS, iItem++, 500, 180, 100, 100,
				"value1=WHITE;value2=BLACK;value3=RED;value4=BLUE;value5=GREEN;value6=YELLOW;value7=MAGENTA;value8=CYAN;value9=MAGENTA;value10=LIGHTGREY;value11=GREY;value12=DARKGREY;value13=-1;remark=Couleur du fond du champ STATIC");

	iError = BG_FormItemAdd ("static", "horizalign", BG_ITEM_STATIC, iItem++, 60, 210, 130, 25,
				"value=Alignement horiz.;txvpos=center");
	iError = BG_FormItemAdd ("static", "cbhorizalign", BG_ITEM_COMBOSYS, iItem++, 180, 210, 100, 100,
				"value1=LEFT;value2=CENTER;value3=RIGHT;remark=Alignement horizontal du texte du champ STATIC");

	iError = BG_FormItemAdd ("static", "verticalign", BG_ITEM_STATIC, iItem++, 360, 210, 130, 25,
				"value=Alignement vertic.;txvpos=center");
	iError = BG_FormItemAdd ("static", "cbverticalign", BG_ITEM_COMBOSYS, iItem++, 500, 210, 100, 100,
				"value1=TOP;value2=CENTER;value3=BOTTOM;remark=Alignement vertical du texte du champ STATIC");

	iError = BG_FormItemAdd ("static", "taillebrd", BG_ITEM_STATIC, iItem++, 60, 240, 180, 25,
				"value=Taille bordure;txvpos=center");
	iError = BG_FormItemAdd ("static", "cbtaillebrd", BG_ITEM_COMBOSYS, iItem++, 180, 240, 50, 100,
				"value1=1;value2=0;value3=2;value4=3;value5=4;value6=5;value7=6;value8=8;value9=10;value10=12;value11=16;remark=Taille de la bordure");

	iError = BG_FormItemAdd ("static", "couleurbrd", BG_ITEM_STATIC, iItem++, 360, 240, 130, 25,
				"value=Couleur bordure;txvpos=center");
	iError = BG_FormItemAdd ("static", "cbcouleurbrd", BG_ITEM_COMBOSYS, iItem++, 500, 240, 100, 100,
				"value1=BLACK;value2=WHITE;value3=RED;value4=BLUE;value5=GREEN;value6=YELLOW;value7=MAGENTA;value8=CYAN;value9=MAGENTA;value10=LIGHTGREY;value11=DARKGREY;remark=Couleur de la bordure");

	iError = BG_FormItemAdd ("static", "stylebrd", BG_ITEM_STATIC, iItem++, 60, 270, 130, 25,
				"value=Style bordure;txvpos=center");
	iError = BG_FormItemAdd ("static", "cbstylebrd", BG_ITEM_COMBOSYS, iItem++, 180, 270, 100, 100,
				"value1=SOLID;value2=3DOUT;value3=3DIN;remark=Style de la bordure");

	// cration d'un champ de saisie simple et de son texte
	iError = BG_FormItemAdd ("static", "textetexte", BG_ITEM_STATIC, iItem++, 60, 360, 180, 25,
				"value=Texte du static :;txvpos=center");
	iError = BG_FormItemAdd ("static", "texte", BG_ITEM_EDIT, iItem++, 180, 360, 400, 25, 
				"value=Exemple de champ static;remark=Texte affich dans le static");


	// bouton FERMER
	iError = BG_FormItemAdd ("static", "fermer", BG_ITEM_BUTTON, iItem++, 280, 440, 100, 30,
				"button=ok;value=Fermer;txcol=white;bkcol=red;remark=Ferme le formulaire");

	// affichage du formulaire
	iError = BG_FormCreate ("static", "modal=true;bkcol=lightgrey", 10, 10, 700, 550, Form_Static_Proc);

	// fermeture du formulaire
	iError = BG_FormClose ("static");

}



//-------------------------------------------------------------
//!        Affichage du formulaire Edit                       !
//-------------------------------------------------------------
void Form_Edit (void)
{
	int iItem;
	int iError;

	// initialisation du numero de l'item
	iItem = 1;

	// cration du titre
	iError = BG_FormItemAdd ("edit", "titre", BG_ITEM_STATIC, iItem++, 50, 10, 600, 40,
				"value=Dmonstrateur Formulaire BipGDI (edit);txhpos=center;txvpos=center;ftname=Arial;ftsize=16;ftbold=true;brdsize=1;brdcol=blue");
	iError = BG_FormItemAdd ("edit", "rectangle1", BG_ITEM_RECT, iItem++, 50, 60, 600, 300,
				"brdsize=1;brdstyle=3DOUT");

	// cration d'un champ de saisie simple et de son texte
	iError = BG_FormItemAdd ("edit", "champ1texte", BG_ITEM_STATIC, iItem++, 60, 65, 180, 25,
				"value=Champ de saisie :;txvpos=center");
	iError = BG_FormItemAdd ("edit", "champ1", BG_ITEM_EDIT, iItem++, 180, 65, 400, 25, 
				"remark=Champ de saisie simple");

	// cration d'un champ de saisie date et de son texte
	iError = BG_FormItemAdd ("edit", "champ2texte", BG_ITEM_STATIC, iItem++, 60, 95, 180, 25,
				"value=Date :;txvpos=center");
	iError = BG_FormItemAdd ("edit", "champ2", BG_ITEM_EDIT, iItem++, 180, 95, 100, 25, 
				"type=date;format=dd/mm/yyyy;remark=Saisir une date valide (format jj/mm/aaaa)");
	iError = BG_FormItemAdd ("edit", "champ2texte2", BG_ITEM_STATIC, iItem++, 300, 95, 300, 25,
				"value=Essayez de saisir 1, puis 1/1 ou une date;ftname=Arial;ftsize=10;txvpos=center");

	// cration d'un champ de saisie numrique et de son texte
	iError = BG_FormItemAdd ("edit", "champ3texte", BG_ITEM_STATIC, iItem++, 60, 125, 180, 25,
				"value=Nombre :;txvpos=center");
	iError = BG_FormItemAdd ("edit", "champ3", BG_ITEM_EDIT, iItem++, 180, 125, 100, 25, 
				"type=currency;format=999,88;remark=Saisir un nombre (format 999,99)");

	// cration d'un champ de saisie obligatoire et de son texte
	iError = BG_FormItemAdd ("edit", "champ4texte", BG_ITEM_STATIC, iItem++, 60, 155, 180, 25,
				"value=Champ de saisie :;txvpos=center");
	iError = BG_FormItemAdd ("edit", "champ4", BG_ITEM_EDIT, iItem++, 180, 155, 100, 25, 
				"length=10;notnull=true;value=1234567890;remark=Champ obligatoire de 10 caractres maximum");

	// cration d'un checkbox et de son texte
	iError = BG_FormItemAdd ("edit", "checktexte", BG_ITEM_STATIC, iItem++, 60, 195, 180, 25,
				"value=Case  cocher :;txvpos=center");
	iError = BG_FormItemAdd ("edit", "check", BG_ITEM_CHECKSYS, iItem++, 180, 200, 0, 0, 
				"remark=Case  cocher");


	// bouton FERMER
	iError = BG_FormItemAdd ("edit", "fermer", BG_ITEM_BUTTON, iItem++, 100, 400, 100, 30,
				"button=cancel;value=Fermer;txcol=white;bkcol=red;remark=Ferme le formulaire");

	// bouton Masquer
	iError = BG_FormItemAdd ("edit", "masquer", BG_ITEM_BUTTON, iItem++, 380, 370, 100, 30,
				"value=Masquer;remark=Masque tous les champs");

	// bouton Montrer
	iError = BG_FormItemAdd ("edit", "montrer", BG_ITEM_BUTTON, iItem++, 500, 370, 100, 30,
				"visible=false;value=Montrer;remark=Montre tous les champs");

	// bouton Dsactiver
	iError = BG_FormItemAdd ("edit", "desactiver", BG_ITEM_BUTTON, iItem++, 380, 420, 100, 30,
				"value=Dsactiver;remark=Dsactive tous les champs");

	// bouton Activer
	iError = BG_FormItemAdd ("edit", "activer", BG_ITEM_BUTTON, iItem++, 500, 420, 100, 30,
				"enable=false;value=Activer;remark=Active tous les champs");


	// affichage du formulaire
	iError = BG_FormCreate ("edit", "modal=true;bkcol=lightgrey", 10, 10, 700, 550, Form_Edit_Proc);

	// fermeture du formulaire
	iError = BG_FormClose ("edit");

}



//-------------------------------------------------------------
//!        Affichage du formulaire Tous (les champs)          !
//-------------------------------------------------------------
void Form_Tous (void)
{
	int iItem;
	int iError;

	// initialisation du numero de l'item
	iItem = 1;

	// cration du titre
	iError = BG_FormItemAdd ("tous", "titre", BG_ITEM_STATIC, iItem++, 50, 10, 600, 40,
				"value=Dmonstrateur Formulaire BipGDI (tous);txhpos=center;txvpos=center;ftname=Arial;ftsize=16;ftbold=true;brdsize=1;brdcol=blue");
	iError = BG_FormItemAdd ("tous", "rectangle1", BG_ITEM_RECT, iItem++, 50, 60, 600, 300,
				"brdsize=1;brdstyle=3DOUT");

	// cration d'un champ de saisie simple et de son texte
	iError = BG_FormItemAdd ("tous", "edit1texte", BG_ITEM_STATIC, iItem++, 60, 65, 180, 25,
				"value=Edit :;txvpos=center");
	iError = BG_FormItemAdd ("tous", "edit1", BG_ITEM_EDIT, iItem++, 180, 65, 400, 25, 
				"remark=Champ de saisie simple");

	// cration d'un checkbox et de son texte
	iError = BG_FormItemAdd ("tous", "check1texte", BG_ITEM_STATIC, iItem++, 60, 95, 180, 25,
				"value=CheckSys :;txvpos=center");
	iError = BG_FormItemAdd ("tous", "check1", BG_ITEM_CHECKSYS, iItem++, 180, 100, 100, 25, 
				"check=true;remark=Case  cocher");

	// cration d'un check et de son texte
	iError = BG_FormItemAdd ("tous", "check2texte", BG_ITEM_STATIC, iItem++, 400, 95, 180, 25,
				"value=Check :;txvpos=center");
	iError = BG_FormItemAdd ("tous", "check2", BG_ITEM_CHECK, iItem++, 480, 100, 20, 20, 
				"check=true;remark=Case  cocher ownerdraw;brdstyle=solid;brdsize=3;brdcol=black;bkcol=white;txcol=red");

	// cration d'un combobox et de son texte
	iError = BG_FormItemAdd ("tous", "combo1texte", BG_ITEM_STATIC, iItem++, 60, 125, 180, 25,
				"value=ComboSys :;txvpos=center");
	iError = BG_FormItemAdd ("tous", "combo1", BG_ITEM_COMBOSYS, iItem++, 180, 125, 100, 100, 
				"remark=Combo box;value1=un;value2=deux;value3=trois");

	// cration d'un bouton systme et de son texte
	iError = BG_FormItemAdd ("tous", "bouton1texte", BG_ITEM_STATIC, iItem++, 60, 155, 180, 25,
				"value=ButtonSys :;txvpos=center");
	iError = BG_FormItemAdd ("tous", "bouton1", BG_ITEM_BUTTONSYS, iItem++, 180, 155, 100, 30,
				"remark=Bouton systme - ne rpond pas au clic");

	// cration d'un bouton et de son texte
	iError = BG_FormItemAdd ("tous", "bouton2texte", BG_ITEM_STATIC, iItem++, 400, 155, 180, 25,
				"value=Button :;txvpos=center");
	iError = BG_FormItemAdd ("tous", "bouton2", BG_ITEM_BUTTON, iItem++, 480, 155, 100, 30,
				"value=Bouton;remark=Bouton ownerdraw - ne rpond pas au clic");



	// bouton OK
	iError = BG_FormItemAdd ("tous", "ok", BG_ITEM_BUTTON, iItem++, 300, 400, 100, 30,
				"button=ok;value=OK;bkcol=green;remark=Ferme le formulaire");


	// affichage du formulaire
	iError = BG_FormCreate ("tous", "modal=true;bkcol=lightgrey", 10, 10, 700, 500);

	// fermeture du formulaire
	iError = BG_FormClose ("tous");

}



//-------------------------------------------------------------
//!    Procedure for main window                              !
//-------------------------------------------------------------
LRESULT CALLBACK WndProc (HWND hBGCurWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	int iError;
	string sMenu;
	BG_STRUCT_MENU Menu;


	switch (message)
	{
		case WM_PAINT:
		{
			// active la fenetre
			BG_WindowSelect ("Main");

			// desactive la fenetre
			BG_WindowRelease ();
			
			return 0;
		}
	}


	// indique le menu selectionn
	sMenu = BG_MenuMessage ("menu", message, wParam);

	// traitement des menus
	if (sMenu != "")
	{
		if (sMenu == "quitter")
		{
			PostQuitMessage (0);
			return 0;
		}
		else if (sMenu == "ouvrir")
		{
			BG_MessageBox ("Ouvrir", "Il n'y a rien  ouvrir, utilisez le menu Formulaires");
			return 0;
		}
		else if (sMenu == "static")
		{
			Form_Static ();
			return 0;
		}
		else if (sMenu == "edit")
		{
			Form_Edit ();
			return 0;
		}
		else if (sMenu == "tous")
		{
			Form_Tous ();
			return 0;
		}
	}
	
	
	// gestion automatique des messages
	iError = BG_WindowMessageAuto (message, wParam);


	return DefWindowProc (hBGCurWnd, message, wParam, lParam);

}



//-------------------------------------------------------------
//!        BEGINING OF PROGRAM                                !
//-------------------------------------------------------------
int APIENTRY WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine,
					  int nCmdShow)
{

	int iError;


	// ouverture fenetre principale
	iError = BG_WindowMainCreate ("Main", nCmdShow, WndProc, "name=DemoForm v1.1", 0, 0, 800, 600);
	if (iError != 0)
		return iError;

	// chargement du menu
	Load_Menu ();

	// boucle de messages
	return BG_MessageLoop();

}
